<template>
  <div class="base-express-container">
    <vab-query-form>
      <vab-query-form-right-panel :span="24">
        <el-form :inline="true" :model="queryForm" @submit.native.prevent>
          <el-form-item>
            <el-input
              v-model.trim="queryForm.express_name"
              clearable
              :placeholder="__('请输入快递公司名称')"
              style="width: 200px"
            />
          </el-form-item>
          <el-form-item>
            <el-button icon="el-icon-search" type="primary" @click="queryData">
              {{ __('查询') }}
            </el-button>
            <el-button icon="el-icon-refresh" type="primary" @click="queryData">
              {{ __('刷新') }}
            </el-button>
          </el-form-item>
        </el-form>
      </vab-query-form-right-panel>
    </vab-query-form>
    <el-table
      v-loading="listLoading"
      border
      :data="list"
      :height="tableConfig.height"
    >
      <el-table-column align="center" :label="__('操作')" width="120">
        <template #default="{ row }">
          <el-button type="text" @click="handleDelete(row)">
            {{ __('删除') }}
          </el-button>
        </template>
      </el-table-column>
      <el-table-column
        align="center"
        :label="__('快递公司编号')"
        prop="express_id"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :label="__('快递公司')"
        prop="express_name"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :label="__('快递公司')"
        prop="express_pinyin"
        show-overflow-tooltip
      />

      <el-table-column
        align="center"
        :label="__('官网')"
        prop="express_site"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :formatter="formatFav"
        :label="__('是否常用')"
        prop="express_is_fav"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :label="__('排序')"
        prop="express_order"
        show-overflow-tooltip
      />
      <el-table-column align="center" :label="__('状态')" prop="express_enable">
        <template slot-scope="scope">
          <el-switch
            v-model="scope.row.express_enable"
            :active-value="1"
            :inactive-value="0"
            @change="sChange(scope.row)"
          />
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      background
      :current-page="queryForm.pageNum"
      :layout="layout"
      :page-size="queryForm.pageSize"
      :total="total"
      @current-change="handleCurrentChange"
      @size-change="handleSizeChange"
    />
  </div>
</template>

<script>
  import { translateTitle as __ } from '@/utils/i18n'

  import { doDelete, doEdit, getList } from '@/api/base/express'

  export default {
    name: 'BaseExpress',

    data() {
      return {
        tableConfig: {
          height: window.innerHeight - 220 - 90,
        },
        list: [],
        listLoading: true,
        layout: 'total, sizes, prev, pager, next, jumper',
        total: 0,
        selectRows: '',
        queryForm: {
          pageNum: 1,
          pageSize: 20,
          express_name: '',
        },
      }
    },
    created() {
      this.fetchData()
    },
    methods: {
      __,
      handleDelete(row) {
        this.$baseConfirm(this.__('你确定要删除当前项吗'), null, async () => {
          const { msg, status } = await doDelete({
            express_id: row.express_id,
          })
          if (200 == status) {
            this.$baseMessage(msg, 'success')
          } else {
            this.$baseMessage(msg, 'error')
          }
          await this.fetchData()
        })
      },

      formatFav(row) {
        return row.express_is_fav === 1 ? this.__('是') : this.__('否')
      },
      handleSizeChange(val) {
        this.queryForm.pageSize = val
        this.fetchData()
      },
      handleCurrentChange(val) {
        this.queryForm.pageNum = val
        this.fetchData()
      },
      queryData() {
        this.queryForm.pageNum = 1
        this.fetchData()
      },
      async fetchData() {
        this.listLoading = true
        const { data } = await getList(this.queryForm)
        this.list = data.items
        this.total = data.records
        this.listLoading = false
      },
      async sChange(row) {
        const param = {
          express_id: row.express_id,
          express_enable: row.express_enable,
        }
        const { msg, status } = await doEdit(param)

        if (status == 200) {
          this.$baseMessage(msg, 'success')
        } else {
          this.$baseMessage(msg, 'error')
        }
      },
    },
  }
</script>
